// mggi.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_MGGI_HH_
#define MICAL_MGGI_HH_

#include <vaucanson/fundamental/element.hh>
#include <vaucanson/algebra/concrete/alphabets/predefs.hh>

#include <mical/samples/kind/summary.hh>

#include <utility>

namespace mical {

  using namespace vcsn;
  using std::map;

  template<typename A, typename T, typename Alphabet_>
  Element<A, T>
  change_alphabet(const Element<A, T>& a, 
		  map<typename Alphabet_::letter_t, 
		  typename Alphabet_::letter_t> mappy,
		  Alphabet_ alpha);

} // mical

#include <mical/algorithms/mggi.hxx>

#endif // MICAL_MGGI_HH_
