// mca_to_pta.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_MCA_TO_PTA_HH_
# define MICAL_MCA_TO_PTA_HH_

#include <vaucanson/fundamental/element.hh>

#include <mical/samples/kind/summary.hh>

namespace mical {

  template<typename A, typename T>
  Element<A, T>
  pta_from_mca(const Element<A, T>& mca);

  template<typename A, typename T>
  void
  mca_to_pta(Element<A, T>& a);

} // mical

#include <mical/internal/mca_to_pta.hxx>

#endif // MICAL_MCA_TO_PTA_HH_
