// renumerotation.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_RENUMEROTATION_HH_
# define MICAL_RENUMEROTATION_HH_

#include <vaucanson/fundamental/element.hh>

namespace mical {

  // Apply on ACYCLIC automata only !! 
  // (for example mca/pta ...)

  template<typename A, typename T>
  void 
  standard_renum(Element<A, T>& a);


  
  template<typename A, typename T>
  void 
  frequency_renum(Element<A, T>& a, map<hstate_t, unsigned> mappy);


} // mical

#include <mical/internal/renumerotation.hxx>

#endif // MICAL_RENUMEROTATION_HH_
