// compute_n.hxx
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_COMPUTE_N_HXX_
#define MICAL_COMPUTE_N_HXX_

#include <mical/primitives/compute_n.hh>

namespace mical {

  template <class A, class T, typename Kind_>
  typename compute_kind::compute_kind_traits<Kind_>::type_t 
  compute_n(Element<A, T> a, 
	    typename Element<A, T>::monoid_elt_t word, 
	    unsigned k,
	    Kind_ t)
  {
    Compute_n<A, T, typename Element<A, T>::monoid_elt_t> compute;

    return compute(a, word, k, t);
  }


  template <class A, class T, class Container_>
  void    
  compute_n(Element<A, T> a, 
	    typename Element<A, T>::monoid_elt_t word, 
	    unsigned k, 
	    Container_& res)
  {
    Compute_n<A, T, typename Element<A, T>::monoid_elt_t> compute;
    
    compute(a, word, k, res);
  }
  
} // mical

#endif // MICAL_COMPUTE_N_HXX_
