// semi_increm_presentation.hxx
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_SEMI_INCREM_PRESENTATION_HXX_
#define MICAL_SEMI_INCREM_PRESENTATION_HXX_

#include <mical/samples/kind/concrete/semi_increm_presentation.hh>

#include <mical/tools/choose.hh>

namespace mical {

  template <class Container_>
  void 
  proxy_init(inference_kind::semi_increm, 
	     unsigned& count_pos, 
	     unsigned& count_neg,
	     const Container_& negative,
	     Container_& neg_step)
  {
    count_pos = 0;
    count_neg = negative.size();
    neg_step = negative;
  }
  
  void
  proxy_next_step(inference_kind::semi_increm, 
		  unsigned& count_pos, 
		  unsigned& count_neg)
  {
    count_pos++;
  }


} // mical

#endif // MICAL_SEMI_INCREM_PRESENTATION_HXX_
