// order.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_ORDER_HH_
#define MICAL_ORDER_HH_

#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>

namespace mical {

  using namespace vcsn;

  namespace standard {

    template <class A, class T>
    bool
    operator < (const Element<FreeMonoid<A>, T>& lhs,
		const Element<FreeMonoid<A>, T>& rhs);
    
    template <class A, class T>
    bool
    operator > (const Element<FreeMonoid<A>, T>& lhs,
		const Element<FreeMonoid<A>, T>& rhs);

  } // standard

} // mical

#include <mical/samples/order.hxx>

#endif // MICAL_ORDER_HH_
