// load_sample.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_LOAD_SAMPLE_HH_
# define MICAL_LOAD_SAMPLE_HH_

#include <mical/samples/kind/sample.hh>
#include <mical/samples/kind/presentation.hh>

#include <iostream>
#include <fstream>

namespace mical {  

  template <typename Kind_, typename Container_, typename Word_>
  void 
  load_presentation(Presentation<Kind_, Container_, Word_>& pres, 
		    const char* name_file);

  template <typename Container_, typename Word_>
  void 
  load_pos_sample(FixedSample<Container_, Word_>& sample, 
		  const char* name_file);

  template <typename Container_, typename Word_>
  void 
  load_neg_sample(FixedSample<Container_, Word_>& sample, 
		  const char* name_file);
 
} // mical 

#include <mical/samples/tools/load_sample.hxx>

#endif // MICAL_LOAD_SAMPLE_HH_
