// search_tools.hxx
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_SEARCH_TOOLS_HXX_
#define MICAL_SEARCH_TOOLS_HXX_

#include <mical/tools/search_tools.hh>

namespace mical {

  using std::map;

  template <template<class> class Container_, class A>
  void 
  give_map(Container_<A> container, 
	   map<unsigned, unsigned>& mappy)
  {
    map<A, unsigned> marked;

    unsigned compt = 0;
    for (typename Container_<A>::iterator i = container.begin();
	 i != container.end(); i++)
      {
	if (marked.find(*i) != marked.end())
	  marked[*i]++;
	else
	  marked[*i] = 1;

	mappy[compt] = marked[*i];
	compt++;
      }
  }

} // mical

#endif // MICAL_SEARCH_TOOLS_HXX_
