// order_search.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_ORDER_SEARCH_HH_
# define MICAL_ORDER_SEARCH_HH_

#include <vaucanson/fundamental/element.hh>
#include <vaucanson/automata/concept/automata.hh>

#include <mical/walkers/info.hh>
#include <mical/walkers/security.hh>

#include <algorithm>

namespace mical {

  template <class A, class T, class Task_, class Order_>
  void
  order_search(const Element<A, T>& a, const Order_& order, Task_& task);

  template <class A, class T, class Task_, class Order_>
  void
  order_search(Element<A, T>& a, const Order_& order, Task_& task);

  template <class A, class T, class Task_, class Order_>
  void
  order_search(const Element<A, T>& a, 
	       hstate_t init, 
	       const Order_& order, 
	       Task_& task);

  template <class A, class T, class Task_, class Order_>
  void
  order_search(Element<A, T>& a, 
	       hstate_t init, 
	       const Order_& order, 
	       Task_& task);


} // mical

#include <mical/walkers/order_search.hxx>

#endif // MICAL_ORDER_SEARCH_HH_
