// test_k_ri.cc

#include <vaucanson/fundamental/predefs.hh>
#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>
#include <vaucanson/algebra/concrete/semiring/numerical_semiring.hh>
#include <vaucanson/algebra/concrete/series/polynoms.hh>
#include <vaucanson/tools/usual.hh>

#include <mical/algorithms/k_ri.hh>

#include <mical/samples/tools/load_sample.hh>

int main(int argc, char** argv)
{
  using namespace std;
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra;
  using namespace vcsn::algebra::char_letter;

  Alphabet a;

  a.insert('a');
  a.insert('b');
  
  Words free_monoid(a);
  NumericalSemiring ring;
  Series<NumericalSemiring, Words> s(ring, free_monoid);

  typedef Automata auto_t;
  typedef 
    utility::ref< 
    AutomatonImpl<labels_are_series,
    Series<NumericalSemiring, Words>,
    polynom<Word::value_t, bool>,
    ManyLinks<polynom<Word::value_t, bool>, NoTag, NoTag>,
    NoTag,
    map> >
    implem_t;
  
  Element<auto_t, implem_t> A;

  A.create();

  A.series() = s;


  FixedSample<set<Word>, Word> sample_pos;

  load_pos_sample(sample_pos, "toy.b");

  k_ri(A, 1, sample_pos);

  SAVE_AUTOMATON_DOT_SIMPLE("k_ri", A);

  // NB: to see the step by step construction of automaton
  // uncomment line 57 of include/mical/algorithms/k_ri.hxx's file
  // new .dot files will be maked
  
  return 0;
}
