// test_k_ri.cc

#include <vaucanson/fundamental/predefs.hh>
#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>
#include <vaucanson/algebra/concrete/semiring/numerical_semiring.hh>
#include <vaucanson/algebra/concrete/series/polynoms.hh>
#include <vaucanson/tools/usual.hh>

#include <mical/algorithms/mggi.hh>

#include <mical/algorithms/k_tssi.hh>

#include <mical/samples/tools/load_sample.hh>

int main(int argc, char** argv)
{
  using namespace std;
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra;
  using namespace vcsn::algebra::char_letter;

  Alphabet a;

  a.insert('0');
  a.insert('1');
  a.insert('2');
  a.insert('3');
  a.insert('4');
  
  Words free_monoid(a);
  NumericalSemiring ring;
  Series<NumericalSemiring, Words> s(ring, free_monoid);

  typedef Automata auto_t;
  typedef 
    utility::ref< 
    AutomatonImpl<labels_are_series,
    Series<NumericalSemiring, Words>,
    polynom<Word::value_t, bool>,
    ManyLinks<polynom<Word::value_t, bool>, NoTag, NoTag>,
    NoTag,
    map> >
    implem_t;
  
  Element<auto_t, implem_t> A, B;

  A.create();
  B.create();

  A.series() = s;
  B.series() = s;

  Alphabet b;

  b.insert('a');
  b.insert('b');

  B.series().monoid().alphabet() = b;

  FixedSample<set<Word>, Word> sample_pos;

  load_pos_sample(sample_pos, "toy.c");
  
  k_tssi(A, 1, sample_pos);

  map<Letter, Letter> morphism;

  morphism['0'] = 'a';
  morphism['1'] = 'a';
  morphism['2'] = 'a';
  morphism['3'] = 'b';
  morphism['4'] = 'b';

  B = change_alphabet(A, morphism, b);

  SAVE_AUTOMATON_DOT_SIMPLE("mggi1", A);
  SAVE_AUTOMATON_DOT_SIMPLE("mggi2", B);
  
  return 0;
}
