// test_make_mca.cc

#include <vaucanson/fundamental/predefs.hh>
#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>
#include <vaucanson/algebra/concrete/semiring/numerical_semiring.hh>
#include <vaucanson/algebra/concrete/series/polynoms.hh>
#include <vaucanson/tools/usual.hh>

#include <mical/internal/make_mca.hh>

#include <mical/samples/tools/load_sample.hh>

int main(int argc, char** argv)
{
  using namespace std;
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra;
  using namespace vcsn::algebra::char_letter;

  Alphabet a;

  a.insert('a');
  a.insert('b');
  
  Words free_monoid(a);
  NumericalSemiring ring;
  Series<NumericalSemiring, Words> s(ring, free_monoid);

  typedef Automata auto_t;
  typedef 
    utility::ref< 
    AutomatonImpl<labels_are_series,
    Series<NumericalSemiring, Words>,
    polynom<Word::value_t, bool>,
    ManyLinks<polynom<Word::value_t, bool>, NoTag, NoTag>,
    NoTag,
    map> >
    implem_t;
  
  Element<auto_t, implem_t> A, B;

  A.create();
  B.create();

  Presentation<inference_kind::fixed, set<Word>, Word> pres;

  load_presentation(pres, "toy.a");

  make_mca(A, pres);

  SAVE_AUTOMATON_DOT_SIMPLE("mca1", A);

//   for (Element<auto_t, implem_t>::edge_iterator i = A.edges().begin();
//        i != A.edges().end(); i++)
//     cout << A.origin_of(*i) << " - " << A.aim_of(*i) << " | "
// 	 << A.label_of(*i).begin()->first  << endl;

  FixedSample<set<Word>, Word> sample_pos;

  load_pos_sample(sample_pos, "toy.a");

  make_mca(B, sample_pos);

  SAVE_AUTOMATON_DOT_SIMPLE("mca2", B);

  return 0;
}
