// test_presentation.cc

#include <mical/samples/kind/presentation.hh>

#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>

#include <set>
#include <vector>
#include <string>
#include <iostream>

int main(int argc, char** argv)
{
  using namespace std;
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra::char_letter;
  using std::set;
  using std::string;

  typedef Presentation<inference_kind::fixed, set<Word>, Word> set_sample_t;
  typedef Presentation<inference_kind::fixed, vector<Word>, Word> vector_sample_t;

  set_sample_t a;
  vector_sample_t b;

  a.add_positive("a");
  a.add_positive("aaa");
  a.add_negative("abbb");
  a.add_negative("ab");

  a.del_negative("ab");
  a.del_positive("a");
  
  cout << a.size_positive()<< "|"<< a.size_negative() << "|" << a.size() << endl;

  for (set_sample_t::sample_iterator i = a.p_begin(); i != a.p_end(); i++)
    cout << *i << endl;

  for (set_sample_t::sample_iterator i = a.n_begin(); i != a.n_end(); i++)
    cout << *i << endl;

  cout << a.empty() << endl;

  a.clear();

  cout << a.empty() << endl;

  ////////////////////////////////////////////////////////////////////////////

  b.add_positive("a");
  b.add_positive("aaa");
  b.add_negative("abbb");
  b.add_negative("ab");
  
  b.del_negative("ab");
  b.del_positive("a");
  
  cout << b.size_positive()<< "|"<< b.size_negative() << "|" << b.size() << endl;

//   for (set_sample_t::sample_iterator i = b.p_begin(); i != b.p_end(); i++)
//     cout << *i << endl;

//   for (set_sample_t::sample_iterator i = b.n_begin(); i != b.n_end(); i++)
//     cout << *i << endl;

  cout << b.empty() << endl;

  b.clear();

  cout << b.empty() << endl;

  return 0;
}
