// test_presentation2.cc

#include <mical/samples/kind/presentation.hh>

#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>

#include <set>
#include <vector>
#include <string>
#include <iostream>

int main(int argc, char** argv)
{
  using namespace std;
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra::char_letter;
  using std::set;
  using std::string;

  typedef Presentation<inference_kind::increm, set<Word>, Word> set_sample_t;

  set_sample_t a;
  
  a.add_positive("a");
  a.add_positive("aaa");
  a.add_positive("aaaaa");


  a.add_negative("bbb");
  a.add_negative("b");
  a.add_negative("bbbb");

  a.init();  

  cout << a.size_positive()<< "|"<< a.size_negative() 
       << "|" << a.size() << endl;

  for (unsigned j = 0; j < 8; j++)
    {
      a.next_step();
      cout << a.size_positive()<< "|"<< a.size_negative() << "|" << a.size() << endl;
      for (set_sample_t::sample_iterator i = a.p_begin(); i != a.p_end(); i++)
	cout << *i << "|";
      cout << endl;
     for (set_sample_t::sample_iterator i = a.n_begin(); i != a.n_end(); i++)
	cout << *i << "|";
     cout <<endl;     cout <<endl;
    }

  return 0;
}
