// test_sample.cc

#include <mical/samples/kind/sample.hh>

#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>

#include <set>
#include <vector>
#include <string>
#include <iostream>

int main(int argc, char** argv)
{
  using namespace std;
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra::char_letter;
  using std::set;
  using std::string;

  FixedSample<set<Word>, Word> a;
  FixedSample<vector<Word>, Word> b;
  
  typedef FixedSample<set<Word>, Word> set_sample_t;
  typedef FixedSample<vector<Word>, Word> vector_sample_t;

  a.add_word("a");
  a.add_word("aaa");
  a.add_word("abbb");
  a.add_word("ab");

  a.del_word("ab");
  
  cout << a.size() << endl;

  for (set_sample_t::sample_iterator i = a.begin(); i != a.end(); i++)
    cout << *i << endl;

  a.clear();

  cout << a.words().size() << endl;

  ////////////////////////////////////////////////////////////////////////////

  b.add_word("a");
  b.add_word("aaa");
  b.add_word("abbb");
  b.add_word("ab");

  b.del_word("ab");
  
  cout << b.size() << endl;

//   for (vector_sample_t::sample_iterator i = b.begin(); i != b.end(); i++)
//     cout << *i << endl;

  b.clear();

  cout << b.words().size() << endl;

  return 0;
}
