// test_get_caracteristic.cc

#include <mical/samples/services/get_caracteristic.hh>

#include <vaucanson/fundamental/predefs.hh>
#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>
#include <vaucanson/algebra/concrete/semiring/numerical_semiring.hh>
#include <vaucanson/algebra/concrete/series/polynoms.hh>
#include <vaucanson/tools/usual.hh>


#include <set>
#include <vector>
#include <string>
#include <iostream>

int main(int argc, char** argv)
{
  using namespace std;
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra;
  using namespace vcsn::algebra::char_letter;

  Alphabet a;

  a.insert('a');
  a.insert('b');
  
  Words free_monoid(a);
  NumericalSemiring ring;
  Series<NumericalSemiring, Words> s(ring, free_monoid);

  typedef Automata auto_t;
  typedef 
    utility::ref< 
    AutomatonImpl<labels_are_series,
    Series<NumericalSemiring, Words>,
    polynom<Word::value_t, bool>,
    ManyLinks<polynom<Word::value_t, bool>, NoTag, NoTag>,
    NoTag,
    map> >
    implem_t;
  
  Element<auto_t, implem_t> A;

  A.create();
  
  A.series() = s;

  hstate_t n_0 = A.add_state();
  hstate_t n_1 = A.add_state();

  A.set_initial(n_0);

  A.add_letter_edge(n_0, n_0, 'a');
  A.add_letter_edge(n_0, n_1, 'b');
  A.add_letter_edge(n_1, n_0, 'b');
  A.add_letter_edge(n_1, n_1, 'a');

  A.set_final(n_0);


  Presentation<inference_kind::fixed, set<Word>, Word> pres;

  get_caracteristic(A, pres);
  
  
  cout << "POSTIVE SAMPLE" << endl;
  copy(pres.p_begin(), pres.p_end(), ostream_iterator<Word>(cout, "\n"));

  cout << "NEGATIVE sample" << endl;
  copy(pres.n_begin(), pres.n_end(), ostream_iterator<Word>(cout, "\n"));

  return 0;
}
