// test_is_struct_complete.cc

#include <mical/samples/services/is_struct_complete.hh>

#include <vaucanson/fundamental/predefs.hh>
#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>
#include <vaucanson/algebra/concrete/semiring/numerical_semiring.hh>
#include <vaucanson/algebra/concrete/series/polynoms.hh>
#include <vaucanson/tools/usual.hh>

#include <mical/samples/tools/load_sample.hh>

#include <mical/framework/framework_kind.hh>

#include <set>
#include <vector>
#include <string>
#include <iostream>

int main(int argc, char** argv)
{
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra::char_letter;
  using std::cout;
  using std::endl;

  Alphabet a;

  a.insert('a');
  a.insert('b');
  
  Words free_monoid(a);
  NumericalSemiring ring;
  Series<NumericalSemiring, Words> s(ring, free_monoid);

  typedef Automata auto_t;
  typedef 
    utility::ref< 
    AutomatonImpl<labels_are_series,
    Series<NumericalSemiring, Words>,
    polynom<Word::value_t, bool>,
    ManyLinks<polynom<Word::value_t, bool>, NoTag, NoTag>,
    NoTag,
    map> >
    implem_t;
  
  Element<auto_t, implem_t> A;

  A.create();

  hstate_t n_0 = A.add_state();
  hstate_t n_1 = A.add_state();
  hstate_t n_2 = A.add_state();
  hstate_t n_3 = A.add_state();

  A.set_initial(n_0);

  A.add_letter_edge(n_0, n_1, 'b');
  A.add_letter_edge(n_1, n_2, 'a');

  A.set_final(n_2);

  A.add_letter_edge(n_0, n_3, 'b');

  A.set_final(n_3);


  FixedSample<set<Word>, Word> sample_pos;
  
  load_pos_sample(sample_pos, "sample.toy");

  cout << is_sc_sample(A, sample_pos) << endl;


  Presentation<inference_kind::fixed, set<Word>, Word> pres;

  load_presentation(pres, "sample.toy");

  cout << is_sc_sample(A, pres) << endl;

  return 0;
}
