// test_load_sample.cc

#include <mical/samples/tools/load_sample.hh>

#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>

#include <mical/framework/framework_kind.hh>

#include <iostream>

int main(int argc, char** argv)
{
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra::char_letter;
  using std::cout;
  using std::endl;


  ////////////////////////////////////////////////////////////////////////
  cout << "LOADING PRESENTATION" << endl;

  Presentation<inference_kind::fixed, set<Word>, Word> pres;

  load_presentation(pres, "training/toy.a");

  cout << pres.size() << endl;
  cout << pres.size_positive() << endl;
  cout << pres.size_negative() << endl;

  cout <<"POSITIVE SAMPLE" << endl;

  for (Presentation<inference_kind::fixed, set<Word>, Word>::sample_iterator i = pres.p_begin();
       i != pres.p_end(); i++)
    cout << *i << endl;

  cout <<"NEGATIVE SAMPLE" << endl;

  for (Presentation<inference_kind::fixed, set<Word>, Word>::sample_iterator i = pres.n_begin();
       i != pres.n_end(); i++)
    cout << *i << endl;

  cout << endl;
  ////////////////////////////////////////////////////////////////////////
  cout << "LOADING POSITIVE SAMPLE" << endl;

  FixedSample<set<Word>, Word> sample_pos;

  load_pos_sample(sample_pos, "training/toy.a");

  cout << sample_pos.size() << endl;

  cout <<"SAMPLE" << endl;

  for (FixedSample<set<Word>, Word>::sample_iterator i = sample_pos.begin();
       i != sample_pos.end(); i++)
    cout << *i << endl;
  
  cout << endl;
  ////////////////////////////////////////////////////////////////////////
  cout << "LOADING NEGATIVE SAMPLE" << endl;
  
  FixedSample<set<Word>, Word> sample_neg;

  load_neg_sample(sample_neg, "training/toy.a");

  cout << sample_neg.size() << endl;

  cout <<"SAMPLE" << endl;

  for (FixedSample<set<Word>, Word>::sample_iterator i = sample_neg.begin();
       i != sample_neg.end(); i++)
    cout << *i << endl;

  return 0;
}
